unit main;
{To be improved/added later perhaps...:
- automatic VOB file detection into a folder or subfolder
}
{
______________________________________________________________________________
    main unit
______________________________________________________________________________
}
{TurboVOB - A freeware to prepare DTH7000's video for DVD burning on computer under windows.
Copyright (C) 2005 Didier CADIOU

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program (see gpl.txt file); if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.}
interface

uses
  //personal units :
  language, option, task, taskDialog, processThreadUnit,
  logFormUnit, aboutDialog, 
  //generic units :
  ImgList, Controls, Dialogs, ComCtrls, StdCtrls, Classes,
  Windows, Messages, SysUtils, Variants, Graphics, Forms,
  strUtils, Menus, DateUtils;

const progVersion = '1.0.0';

type
  TForm1 = class(TForm)
    Label1: TLabel;
    btn_demuxAll: TButton;
    ListView1: TListView;
    btn_addVob: TButton;
    OpenDialog1: TOpenDialog;
    btn_clearList: TButton;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    menu_Options: TMenuItem;
    btn_removeVob: TButton;
    chb_stopWhenFinished: TCheckBox;
    Project1: TMenuItem;
    menu_exit: TMenuItem;
    menu_About: TMenuItem;
    btn_displayLog: TButton;
    lab_statusText: TLabel;
    btn_modifyTask: TButton;
    PopupMenu1: TPopupMenu;
    PPmenu_AddTask: TMenuItem;
    PPmenu_ModifyTask: TMenuItem;
    PPmenu_RemoveTask: TMenuItem;
    btn_AbortTasks: TButton;
    menu_SaveProject: TMenuItem;
    SaveDialog1: TSaveDialog;
    StatusBar1: TStatusBar;
    menu_OpenProject: TMenuItem;
    procedure btn_demuxAllClick(Sender: TObject);
    procedure btn_addVobClick(Sender: TObject);
    procedure btn_clearListClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure menu_OptionsClick(Sender: TObject);
    procedure btn_removeVobClick(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure menu_exitClick(Sender: TObject);
    procedure menu_AboutClick(Sender: TObject);
    procedure btn_displayLogClick(Sender: TObject);
    procedure menu_SaveClick(Sender: TObject);
    procedure menu_OpenClick(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure btn_modifyTaskClick(Sender: TObject);
    procedure PPmenu_AddTaskClick(Sender: TObject);
    procedure PPmenu_ModifyTaskClick(Sender: TObject);
    procedure PPmenu_RemoveTaskClick(Sender: TObject);
    procedure btn_AbortTasksClick(Sender: TObject);
    procedure ListView1InfoTip(Sender: TObject; Item: TListItem;
      var InfoTip: String);
    procedure menu_SaveProjectClick(Sender: TObject);
    procedure menu_OpenProjectClick(Sender: TObject);
  private
    { Dclarations prives }
    t0: TDateTime; //for task starting time storage
    rep: Integer; //for user answer
    AllTaskCollection: TAllTask; //collection of all demux/mux task to do
    TasksRun: TprocessThread; //thread used to run all defined tasks independantly
    procedure addVob(); //add a new file to process into the list
    procedure ModifyTask(); //modify the currently selected task
    procedure removeTask(); //remove the currently selected file to process from the list
    procedure loadTask(theTask: Ttask); //open the current task with the task dialog
    procedure OpenOption(); //open the option dialog
    procedure refreshListView(); //to reload the array of tasks content into the listview
    procedure ShowLog(); //display the log file content on the screen
    procedure updateButtons(); //to disable or enable buttons depending on the listview state

    //for thread management :
    procedure TprocessThreadError(sender: tobject; errMessage: string; taskNber: integer);
    procedure TprocessThreadCmdStarted(sender: tobject; progressMessage: string; taskNber: integer); //when a cmd line is started
    procedure TprocessThreadCmdDone(sender: tobject; progressMessage: string; taskNber: integer); //when a cmd line is ended
    procedure TprocessThreadTaskStarted(sender: tobject; progressMessage: string; taskNber: integer); //before all cmd line for this task will be started
    procedure TprocessThreadTerminate(sender: tobject);

  public
    { Dclarations publiques }
    LogFile: textfile; //log file handle
    TaskInProgress: boolean; //true if some tasks has been started and are not finished
    procedure processVideos();
    procedure loadProject();
    procedure saveProject();
  end;

var
  Form1: TForm1;
  //for options :
  optDmuxExePath: string; //path to the demultiplexer software
  optMuxExePath: string; //path to the multiplexer software
  optAuthorExePath: string; //path to the authoring software


implementation

{$R *.dfm}

//--------------------------------------------------------------------------------------------------------
procedure TForm1.processVideos();
{sweep the list of vob, and for each start a demux process}
begin
    TaskInProgress := true; //to indicate that the process has been started

    rewrite(LogFile); //create or overwrite previous log file and clear it
    CloseFile(LogFile); //close it now, but it will be re-opened later for appending

    TasksRun := TprocessThread.Create(false, AllTaskCollection);
    with TasksRun do begin
        OnError := TprocessThreadError;
        OnCmdStarted := TprocessThreadCmdStarted;
        OnCmdDone := TprocessThreadCmdDone;
        OnTaskStarted := TprocessThreadTaskStarted;
        OnTerminate := TprocessThreadTerminate;
    end;

end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.TprocessThreadError(sender: tobject; errMessage: string; taskNber: integer);
begin
    Append(LogFile);
    Writeln(logFile, 'ERROR !!!! ==>>> ' + errMessage + #13#10#13#10#13#10#13#10#13#10#13#10);
    CloseFile(LogFile);
    ListView1.Items[taskNber].ImageIndex := 2; //"error" icon in front of the current line (inside the listview)

end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.TprocessThreadCmdStarted(sender: tobject; progressMessage: string; taskNber: integer);
var
    t: ansiString; //the text to write
begin
    //display progress on the screen :
    lab_statusText.Caption := progressMessage;

    //write progress information into the log file :
    t := '    ' + DateTimeToStr(now()) + ' : ' + progressMessage;
    Append(LogFile);
    Writeln(logFile, t);
    CloseFile(LogFile);
    
    t0 := now(); //store the current time to be able to calculate later the duration of the next operation

end;
//--------------------------------------------------------------------------------------------------------
procedure TForm1.TprocessThreadCmdDone(sender: tobject; progressMessage: string; taskNber: integer);
var
    t: ansiString; //the text to write
    duration: integer; //cmd line duration expressed in seconds
begin
    //display progress on the screen :
    lab_statusText.Caption := progressMessage;

    //write progress information into the log file :
    t := '    ' + progressMessage ;
    if t0 <> 0 then begin
        duration := SecondsBetween(now(), t0);
        t := t + rstrDURATION + intToStr(duration) +'s '#13#10;
        //if duration < 5 then t := t + rstrCAUTION_SHORT_TASK + #13#10;
    end;
    t := t + '    ______________________';

    Append(LogFile);
    Writeln(logFile, t);
    CloseFile(LogFile);
end;
//--------------------------------------------------------------------------------------------------------
procedure TForm1.TprocessThreadTaskStarted(sender: tobject; progressMessage: string; taskNber: integer);
var
    t: ansiString; //the text to write
begin

    //display progress using the listview icons :
    ListView1.Items[taskNber].ImageIndex := 0; //"arrow" icon in front of the current line (inside the listview)
    if (taskNber>0) and //if this task is not the first
        (ListView1.Items[taskNber - 1].ImageIndex <> 2) then begin //if the icon of the previous task is not an "error" icon
            ListView1.Items[taskNber - 1].ImageIndex := 1; //apply "checked" icon in front of the previous task (inside the listview)
    end;

    //update buttons validation to avoid task modification while it is processed
    updateButtons;

    //write progress information into the log file :
    t := #13#10#13#10#13#10'__________________________________________________________________________________________'#13#10  +
        '    ' + rstrNEW_TASK + progressMessage + intToStr(taskNber) + #13#10;

    Append(LogFile);
    Writeln(logFile, t);
    CloseFile(LogFile);

end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.TprocessThreadTerminate(sender: tobject);
var
    t: ansiString; //the text to write
begin
    lab_statusText.Caption := rstrALL_TASKS_FINISHED;

    //update icon in front of the last task :
    if (ListView1.Items[ListView1.Items.Count-1].ImageIndex <> 2) then begin //if the icon of the last task is not an "error" icon
            ListView1.Items[ListView1.Items.Count-1].ImageIndex := 1; //apply "checked" icon in front of the last task (inside the listview)
    end;

    t := '__________________________________________________________________'#13#10+ rstrFINISHED;
    Append(LogFile);
    Writeln(logFile, t);
    CloseFile(LogFile); //close the log file "definitely"

    if Form1.chb_stopWhenFinished.Checked = true then begin
        Application.Terminate; //if asked stop at end
    end else begin
        ShowLog;
    end;

    TaskInProgress := false; //to indicate that the process is now finished

    updateButtons;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.ShowLog();
//display the log file
var
    displayLog: TLogForm; //form in which the log file will be displayed
    logFileName: string;
begin
    logFileName := ChangeFileExt(Application.ExeName, '.log');

    if FileExists(logFileName) = true then begin
        displayLog := TLogForm.Create(logFileName, self);
        displayLog.Show;
    end else begin
        MessageDlg(rstrNO_LOG_FILE, mtWarning, [mbOK], 0);
    end;
end;


//--------------------------------------------------------------------------------------------------------
procedure TForm1.btn_clearListClick(Sender: TObject);
begin
    AllTaskCollection.clear;
    refreshListView;
end;



//--------------------------------------------------------------------------------------------------------
procedure TForm1.ListView1DblClick(Sender: TObject);
begin
    if TaskInProgress = true then exit; //no modification while at least one task is in progress
    ModifyTask;
end;
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
procedure TForm1.btn_modifyTaskClick(Sender: TObject);
begin
    ModifyTask;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.btn_demuxAllClick(Sender: TObject);
begin
    processVideos;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.btn_addVobClick(Sender: TObject);
begin
    addVob;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.btn_removeVobClick(Sender: TObject);
//remove one vob file from the list
begin
    removeTask;
end;
//--------------------------------------------------------------------------------------------------------
procedure TForm1.PPmenu_AddTaskClick(Sender: TObject);
begin
    addVob;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.PPmenu_ModifyTaskClick(Sender: TObject);
begin
    ModifyTask;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.PPmenu_RemoveTaskClick(Sender: TObject);
begin
    removeTask;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.addVob;
{fill the list with vob files selected by the user}
var
    newTask: Ttask; //the new task to define
    defineTask: TFormTaskManager; //dialog to define the task
    dialogOK: integer; //user's action when quiting the dialog (true if the user clicked on OK button)
begin
    //open the dialog :
    newTask := Ttask.Create; //create the new task that will be defined soon
    defineTask := TFormTaskManager.Create(self, newTask);
    defineTask.BrowseForOriginalVOB;
    dialogOK := defineTask.ShowModal; //open the dialog to define the task
    if dialogOK = mrCancel then exit; //abort if cancelled by the user

    //Add this task to the collection :
    AllTaskCollection.add(newTask);

    refreshListView; //update the listview content accordingly

end;
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
procedure TForm1.refreshListView();
{reload array of tasks content into the listView}
var
    ix: integer; //loop index
    listItem: TListItem;
begin
    ListView1.Items.Clear; //clear before adding the current the tasks list into

    for ix := 0 to (AllTaskCollection.Count -1) do begin
        //update the listview :
        listItem := ListView1.Items.Add;//add a new line in the list
        With ListItem do begin
            ImageIndex := -1; //no icon inside the listview at the beginning

            //in column "task ID" : --------------------
            caption := intToStr(ix);

            //in column "name" : --------------------
            if AllTaskCollection.tasks[ix].ToBeDemuxed = true then begin
                SubItems.Add(AllTaskCollection.tasks[ix].originalVobPath);
            end else begin //no demux to be done, source = already demuxed stream
                SubItems.Add(AllTaskCollection.tasks[ix].videoStreamPath); //display the video stream path instead of vob path
            end;
        end;
    end;

    updateButtons; //enable or not appropriate buttons
end;
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
procedure TForm1.updateButtons();
{to disable or enable buttons depending on the listview state}
begin

    if ListView1.Items.Count = 0 then begin //if the list is empty
        //some actions (linked with controls below) can't be done if the list is empty
        btn_demuxAll.Enabled := false;
        btn_modifyTask.Enabled := false;
        btn_removeVob.Enabled := false;
        btn_clearList.Enabled := false;
        PPmenu_ModifyTask.Enabled := false;
        PPmenu_RemoveTask.Enabled := false;

    end else begin //if the list is not empty
        if (ListView1.SelCount > 0) //if, at least, 1 item is selected in the list
            and (ListView1.Selected.ImageIndex <> 0) then begin {and if the currently
                selected task icon is not an "arrow" wich guarantee that this task
                is not currently being processed}
            //enable access to task modification feature:
            btn_modifyTask.Enabled := true;
            btn_removeVob.Enabled := true;
            PPmenu_ModifyTask.Enabled := true;
            PPmenu_RemoveTask.Enabled := true;
        end else begin //otherwise disable them
            btn_modifyTask.Enabled := false;
            btn_removeVob.Enabled := false;
            PPmenu_ModifyTask.Enabled := false;
            PPmenu_RemoveTask.Enabled := false;
        end;
        btn_demuxAll.Enabled := true;
        btn_clearList.Enabled := true;

    end;

    if TaskInProgress = true then begin //if 1 task is currently processed (indicated by an "arrow" icon)
        btn_demuxAll.Enabled := false; //to avoid a possible restart while the previous start is not finished
        btn_AbortTasks.Enabled := true; //to allow the user to abort the process
    end else begin
        btn_AbortTasks.Enabled := false; //not needed until tasks are started
    end;


end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.ModifyTask();
begin
    if ListView1.Selected <> nil then begin
        loadTask(AllTaskCollection.Tasks[strToInt(ListView1.Selected.caption)]);
    end;
end;
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
procedure TForm1.loadTask(theTask: Ttask);
{open the task dialog to watch in detail the current (selected) task}
var
    defineTask: TFormTaskManager; //dialog to define the task
    dialogOK: integer; //user's action when quiting the dialog (true if the user clicked on OK button)
begin
    //open the dialog :
    defineTask := TFormTaskManager.Create(self, theTask);
    dialogOK := defineTask.ShowModal; //open the dialog to define the task
    if dialogOK = mrCancel then exit; //abort if cancelled by the user

    refreshListView;

end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.removeTask();
//remove one task from the list
begin
    if ListView1.Selected <> nil then begin
        AllTaskCollection.delete(strToInt(form1.ListView1.Selected.Caption)); //delete one task inside the task list (array of tasks)
        refreshListView; //update the listview accordingly
    end;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.menu_OptionsClick(Sender: TObject);
begin
    OpenOption;
end;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
procedure TForm1.OpenOption();
{open the options dialog}
var
    optDialog: TFormOptions;
begin
    optDialog := TFormOptions.Create(self);
    optDialog.ShowModal;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
    optDialog: TFormOptions;

begin
    optDialog := TFormOptions.Create(self); //load current settings from the ini file
    optDialog.Free;

    AllTaskCollection := TAllTask.Create(); //start with a default list off task

    AssignFile(LogFile, ChangeFileExt(Application.ExeName, '.log')); //to log task execution inside

    updateButtons;
end;




//--------------------------------------------------------------------------------------------------------
procedure TForm1.menu_exitClick(Sender: TObject);
begin
    application.Terminate;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.menu_AboutClick(Sender: TObject);
var
    AboutForm: TFAbout;
    progName: string;
begin
    //extract the application name :
    progName := ExtractFileName(application.ExeName);
    setlength(progName, length(progName)-4);

    //display the about dialog :
    AboutForm := TFAbout.Create(ExtractFilePath(application.ExeName) + 'gpl.txt', self);
    AboutForm.lblProgramNameVersion.Caption := progName + ' ' + progVersion;
    AboutForm.ShowModal;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.btn_displayLogClick(Sender: TObject);
begin
    ShowLog;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.saveProject();
{save current defined tasks into a project file = text file with 1 chapter per task}
var
    projectFile: TextFile; //destination file
    ix: integer; //loop index
begin
    //define save dialog characteristics :
    with saveDialog1 do begin
        Title := rstrENTER_PROJECT_NAME;
        DefaultExt := 'tvb';
        Filter := 'TurboVOB project (*.tvb)|*.tvb';
    end;

    try
        self.Cursor := crHourGlass;
        self.StatusBar1.SimpleText := rstrPROJECT_SAVE_IN_PROGRESS;
        if saveDialog1.Execute then begin
            //open the selected file destination :
            AssignFile(projectFile, SaveDialog1.FileName); //define the file
            rewrite(projectFile); //open it for writing

            //write the project informations into it :
            Writeln(projectFile, intToStr(AllTaskCollection.Count)); //Nber of tasks recorded into the project (usefull at project loading)

            for ix := 0 to AllTaskCollection.Count -1 do begin //sweep through all tasks
                Writeln(projectFile, '____________________________________'); //to separate tasks into the file
                with AllTaskCollection.tasks[ix] do begin
                    Writeln(projectFile, originalVobPath);
                    Writeln(projectFile, videoStreamPath);
                    Writeln(projectFile, audioStreamPath);
                    Writeln(projectFile, VobPath);
                    Writeln(projectFile, destinationFolder);
                    Writeln(projectFile, chapterListStr);
                    Writeln(projectFile, boolToStr(ToBeDemuxed, true));
                    Writeln(projectFile, boolToStr(ToBeAuthored, true));
                    Writeln(projectFile, boolToStr(deleteOriginalVob, true));
                    Writeln(projectFile, boolToStr(deleteStreams, true));
                    Writeln(projectFile, boolToStr(deleteRemuxedVob, true));
                end; //with AllTaskCollection.tasks[ix]
            end; //for each task
            CloseFile(projectFile);

        end; //if savedialogs.execute

    finally
        self.Cursor := crDefault;
        self.StatusBar1.SimpleText := ''; //reset statusbar

    end;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.loadProject();
{load previously saved project to import tasks into the current session
it read the project file (text file with 1 chapter per task)}
var
    projectFile: TextFile; //project file
    ix: integer; //loop index
    NberOfTasks: integer; //to know how many tasks should be read
    tmpStr: string; //temporary string used during file reading
    aTask: Ttask; //temporary tasks
begin
    //init:
    AllTaskCollection.clear; //clear it to free the space for the loaded project

    //define save dialog characteristics :
    with OpenDialog1 do begin
        Title := rstrENTER_PROJECT_NAME;
        DefaultExt := 'tvb';
        Filter := 'TurboVOB project (*.tvb)|*.tvb';
    end;

    try
        self.Cursor := crHourGlass;
        self.StatusBar1.SimpleText := rstrPROJECT_LOAD_IN_PROGRESS;
        if OpenDialog1.Execute then begin
            //open the selected file destination :
            AssignFile(projectFile, OpenDialog1.FileName); //define the file
            reset(projectFile); //open it for reading

            //write the project informations into it :
            Readln(projectFile, tmpStr); //Nber of tasks recorded into the project
            NberOfTasks := strToInt(tmpStr);

            for ix := 0 to NberOfTasks -1 do begin //sweep through all tasks
                aTask := Ttask.Create(); //create as many temporary tasks as it has been saved into the project
                Readln(projectFile, tmpStr); //read the tasks separation line, but ignore it
                with aTask do begin //define the current task (affect saved value to its properties)
                    Readln(projectFile, tmpStr); //read originalVobPath in the temporary string
                    originalVobPath := tmpStr; //affect the temporary string to the appropriate property

                    Readln(projectFile, tmpStr); //videoStreamPath
                    videoStreamPath := tmpStr;

                    Readln(projectFile, tmpStr); //audioStreamPath
                    audioStreamPath := tmpStr;

                    Readln(projectFile, tmpStr); //VobPath
                    VobPath := tmpStr;

                    Readln(projectFile, tmpStr); //destinationFolder
                    destinationFolder := tmpStr;

                    Readln(projectFile, tmpStr); //chapterListStr
                    chapterListStr := tmpStr;

                    Readln(projectFile, tmpStr); //ToBeDemuxed
                    ToBeDemuxed := false;
                    if tmpStr = 'True' then ToBeDemuxed := true;

                    Readln(projectFile, tmpStr); //ToBeAuthored
                    ToBeAuthored := false;
                    if tmpStr = 'True' then ToBeAuthored := true;

                    Readln(projectFile, tmpStr); //deleteOriginalVob
                    deleteOriginalVob := false;
                    if tmpStr = 'True' then deleteOriginalVob := true;

                    Readln(projectFile, tmpStr); //deleteStreams
                    deleteStreams := false;
                    if tmpStr = 'True' then deleteStreams := true;

                    Readln(projectFile, tmpStr); //deleteRemuxedVob
                    deleteRemuxedVob := false;
                    if tmpStr = 'True' then deleteRemuxedVob := true;
                end; //with atasks
                AllTaskCollection.add(aTask);
            end; //for each task

            CloseFile(projectFile);
            refreshListView; //to load the task collection object into the listView to display it
        end; //if savedialogs.execute

    finally

        self.Cursor := crDefault;
        self.StatusBar1.SimpleText := ''; //reset statusbar

    end;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.menu_SaveClick(Sender: TObject);
begin
    saveProject;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.menu_OpenClick(Sender: TObject);
begin
    loadProject;
end;
//--------------------------------------------------------------------------------------------------------
procedure TForm1.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
  {once the selection change, update buttons validation}
begin
    updateButtons;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.btn_AbortTasksClick(Sender: TObject);
var
    t: AnsiString;
begin
    if TaskInProgress = true then begin
        TasksRun.Terminate;
        t := rstrPROCESS_ABORTED + #13#10;
        Append(LogFile);
        Writeln(logFile, t);
        CloseFile(LogFile);
    end;
end;





procedure TForm1.ListView1InfoTip(Sender: TObject; Item: TListItem;
  var InfoTip: String);
var
    theTask: Ttask;
    t: string; //temporary string
begin

    theTask := AllTaskCollection.tasks[strToInt(Item.Caption)];

    //string creation :
    t := ''; //init
    if theTask.ToBeDemuxed = true then begin
        t := t + theTask.originalVobPath;
        if theTask.deleteOriginalVob = true then t := t + ' (tmp)';
        t := t + #13#10 +  '   ' + rstrDEMUXED_TO + #13#10;
    end;

    t := t + theTask.videoStreamPath;
    if theTask.deleteStreams = true then t := t + ' (tmp)';
    t := t  + #13#10 + theTask.audioStreamPath;
    if theTask.deleteStreams = true then t := t + ' (tmp)';

    if theTask.ToBeAuthored = true then begin
        t := t + #13#10 + '   ' + rstrREMUXED_TO + #13#10;
        t := t + theTask.VobPath;
        if theTask.deleteRemuxedVob = true then t := t + ' (tmp)';
        t := t + #13#10 + '   ' + rstrREAUTHORED_INTO + #13#10;
        t := t + theTask.destinationFolder + #13#10;
        t := t +  '   ' + rstrWITH_CHAPTERS + #13#10;
        t := t + WrapText(theTask.chapterListStr, #13#10, [','], 45) + #13#10; //chapter marks display with wrap text to avoid too long line
        t := t + #13#10#13#10 + rstrX_FOR_DELETED;
    end;

    InfoTip := t;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.menu_SaveProjectClick(Sender: TObject);
begin
    saveProject;
end;

//--------------------------------------------------------------------------------------------------------
procedure TForm1.menu_OpenProjectClick(Sender: TObject);
begin
    loadProject;
end;

end.


